// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from com_verifone_commerce_payment.djinni

#pragma once

#include <cstdint>
#include <memory>
#include <optional>
#include <string>
#include <vector>

namespace verifone_sdk {

class AmountAdjustedEventResponse;
class AmountAdjustment;
class Payment;
class Transaction;

/**
 * When the amount is adjusted by applications in response to the
 * {@link com.verifone.commerce.triggers.AmountAdjustmentRequest} Trigger, the
 * adjustments proposed  are returned in this event. This allows the POS
 * application to keep track of changes and provides the opportunity to decide
 * which adjustments are applied in the response.
 */
class AmountAdjustedEvent {
public:
    virtual ~AmountAdjustedEvent() {}

    /** The constant event type for amount adjusted. */
    static std::string const TYPE;

    /** Returns the message associated with the event */
    virtual std::optional<std::string> getMessage() const = 0;

    /** Get the session ID for the session which triggered this event. */
    virtual std::optional<std::string> getSessionId() const = 0;

    /** Returns the Event constants */
    virtual std::optional<std::string> getType() const = 0;

    /** Returns the event status */
    virtual int32_t getStatus() const = 0;

    /** Return event id from this event */
    virtual std::optional<std::string> getEventId() const = 0;

    /** Return invoice id from this event */
    virtual std::optional<std::string> getInvoiceId() const = 0;

    /** Return transaction from event */
    virtual std::shared_ptr<Transaction> getTransaction() const = 0;

    /** Get the adjustments applied by other applications. */
    virtual std::vector<std::shared_ptr<AmountAdjustment>> getAdjustments() const = 0;

    /** Get the appropriate payment object that led to this adjustment. */
    virtual std::shared_ptr<Payment> getPayment() const = 0;

    /** Generate amount adjusted event response */
    virtual std::shared_ptr<AmountAdjustedEventResponse> generateAmountAdjustedEventResponse() const = 0;

    /**
     * Return boolean indicating that the event occurred
     * during payment hence is a PaymentAdjustedEvent
     */
    virtual bool isPaymentAdjustedEvent() const = 0;
};

}  // namespace verifone_sdk
